﻿// =========================================================================================================
// Panel: Display - v2.0build20191010
// =========================================================================================================

var vu_style = window.GetProperty("VU Style", 0), VUback = configPath + "settings\\" + "DO4M_VU_BACK_";
axo.fso.FileExists(VUback + vu_style) ? null : axo.fso.CreateTextFile(VUback + vu_style, true);

// ----- DRAW -----
function on_paint(gr) {
	!window.IsTransparent && gr.FillSolidRect(0, 0, ww, wh, p_backcol);
	display_system.draw(gr);
}

// ----- MOUSE ACTIONS -----
function on_mouse_rbtn_up(x, y) {
	if (display_system.traceMouse(x, y)) {
		var a = {}, b = "Style 1;Style 2;Style 3;Style 4;Style 5;Style 6".split(";");

		for (var i = 0; i < 4; i++) a[i] = window.CreatePopupMenu();

		a[1].AppendMenuItem(0, 1, "Plain Font");
		a[1].AppendMenuItem(0, 2, "Dot Matrix");
		a[1].CheckMenuRadioItem(1, 2, display_system.display_style + 1);

		for (var j = 0; j < 6; j++) a[2].AppendMenuItem(0, 3 + j, display_system.display_arr[j]);
		a[2].CheckMenuRadioItem(3, 8, display_system.display_colour + 3);

		for (var k = 0; k < 6; k++) a[3].AppendMenuItem(0, 9 + k, b[k]);
		a[3].CheckMenuRadioItem(9, 14, vu_style + 9);

		a[1].AppendTo(a[0], 0 | 16, "Display Style");
		a[2].AppendTo(a[0], 0 | 16, "Display Colour");
		a[3].AppendTo(a[0], 0 | 16, "VU Meter Style");

		var idx = a[0].TrackPopupMenu(x, y);

		switch (true) {
			case idx == 0:
				break;

			case idx < 3:
				window.SetProperty("Display Style", idx - 1);
				display_system.display_style = window.GetProperty("Display Style");
				display_system.InitImages();
				display_system.init();
				display_system.repaint(g_all);
				break;

			case idx < 9:
				window.SetProperty("Display Colour (0-5)", idx - 3);
				display_system.InitColours();
				display_system.setColours();
				for (var j = 0; j < 5; j++) display_system.images[j] && display_system.images[j].reset();
				display_system.repaint(g_all);
				fb.RunMainMenuCommand("View/Visualizations/Analog VU Meter skins/DarkOne4MOD/" + vu_style + " " + display_system.display_arr[display_system.display_colour]);
				break;

			case idx < 15:
				var old_style = window.GetProperty("VU Style");
				window.SetProperty("VU Style", idx - 9);
				vu_style = window.GetProperty("VU Style");
				if (old_style != vu_style) {
					axo.fso.DeleteFile(VUback + "*");
					axo.fso.CreateTextFile(VUback + vu_style, true);
					fb.IsPlaying || fb.IsPaused ? null : (fb.Play(), fb.Stop());
					fb.RunMainMenuCommand("View/Visualizations/Analog VU Meter skins/DarkOne4MOD/" + vu_style + " " + display_system.display_arr[display_system.display_colour]);
				}
				break;
		}

		for (var l = 0; l < 4; l++) a[l].Dispose();

		return true;
	}
}

// ----- EVENTS -----
function on_size() {
	ww = window.Width;
	wh = window.Height;
	display_system.initPos();
}

function on_volume_change(val) {
	display_system.VolumeChange(val);
}

function on_notify_data(name, info) {
	display_system.NotifyData(name, info);
}

function on_playlist_stop_after_current_changed(state) {
	display_system.repaint(g_sac);
}

function on_playback_order_changed(new_order) {
	display_system.repaint(g_pbo);
}

function on_playback_new_track(metadb) {
	display_system.init();
	display_system.repaint(g_all);
}

function on_playback_time(time) {
	display_system.PlayTime(time);
}

function on_playback_dynamic_info() {
	display_system.PlayDynInfo();
}

function on_playback_edited() {
	display_system.PlayEdited();
}

function on_playback_pause(state) {
	display_system.repaint(g_pbt);
}

function on_playback_stop(reason) {
	display_system.onStop(reason);
}

function on_script_unload() {
	display_system.onUnload();
}